#ifndef _MAIN_H
 #define _MAIN_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/eeprom.h>
#include <avr/delay.h>
#include <avr/sleep.h>

#define nop()  __asm__ __volatile__ ("nop" ::)

#define S1E		1		//PB0		//Segment of Ports with Colon for clock
#define S1D		2		//PB1		
#define	S1C		4		//PB2
#define S2E		8		//PB3
#define S2D		16		//PB4	
#define	S2C		32		//PB5
#define S3E		64		//PB6
#define S3D		128		//PB7
#define	S3C		1		//PD0
#define Komma	2		//PD1
#define S4E		8		//PD3
#define S4D		16		//PD4
#define	S4C		32		//PD5
#define S4B		64		//PD6
#define S4A		128		//PD7
#define	S4F		1		//PC0
#define S4G		2		//PC1
#define S3B		4		//PC2
#define	S3A		8		//PC3
#define S3F		16		//PC4
#define S3G		32		//PC5
#define Colon	64		//PC6
#define	S2B		128		//PC7
#define S2A		128		//PA7
#define S2F		64		//PA6
#define	S2G		32		//PA5
#define S1B		16		//PA4
#define S1A		8		//PA3
#define	S1F		4		//PA2
#define	S1G		2		//PA1
#define	BACK	1		//PA0 , Backplane


// *************** LCD patterns **************
#define empty	10		//LCD off
#define minus	11		//LCD dash
#define speedmark 12	//mark speed mode
#define cir		13		//mark to go to wheel mode
#define maxspeedmark 14	//mark max speed mode
#define turnoff	15		//mark to go to off
// *******************************************
#define key_min	1		//Key minus
#define key_plus 2		//Key plus
#define key_all	0		//both keys
#define key_none 3		//no key pressed
#define wait1	20		//wait for key long enough pressed
#define wait2	14		//slow counting
#define wait3	2		//fast counting	
#define wait4	15		//loop so often before fast count
#define trip	0		//trip mode
#define wheel	1		//wheel circum mode
#define clock	2		//clock mode
#define setclk	18		//set clock mode
#define speed	3		//speed mode
#define shutdown 5		//shutdown mode
#define maxspeed 4		//max speed mode
#define slowest 8000	//longest time before speed is considered 0

// ***** for speed calculation
#define timerfrequ 64	//frequency of timer ticks
#define frequ	4		//Timer frequ. in KHz, here 4096 Hz
#define preload	192		//256-frequ*1000/64, determine frequency of timer2 
#define steps 64		//frequ*1000/64, steps @ frequ KHz per timer tick

	
#define EEPROM  __attribute__ ((section (".eeprom")))

#endif //_MAIN_H
